<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="设备ID" prop="deviceId">
        <el-input v-model="formData.deviceId" placeholder="请输入设备ID" />
      </el-form-item>
      <el-form-item label="负责人ID" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入负责人ID" />
      </el-form-item>
      <el-form-item label="负责人姓名" prop="userName">
        <el-input v-model="formData.userName" placeholder="请输入负责人姓名" />
      </el-form-item>
      <el-form-item label="负责人工号" prop="userCode">
        <el-input v-model="formData.userCode" placeholder="请输入负责人工号" />
      </el-form-item>
      <el-form-item label="责任类型(负责人/管理员等)" prop="responsibilityType">
        <el-select v-model="formData.responsibilityType" placeholder="请选择责任类型(负责人/管理员等)">
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ResponsibleApi, Responsible } from '@/api/device/responsible'

/** 设备负责人 表单 */
defineOptions({ name: 'ResponsibleForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  userId: undefined,
  userName: undefined,
  userCode: undefined,
  responsibilityType: undefined,
  remark: undefined,
})
const formRules = reactive({
  deviceId: [{ required: true, message: '设备ID不能为空', trigger: 'blur' }],
  userName: [{ required: true, message: '负责人姓名不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ResponsibleApi.getResponsible(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Responsible
    if (formType.value === 'create') {
      await ResponsibleApi.createResponsible(data)
      message.success(t('common.createSuccess'))
    } else {
      await ResponsibleApi.updateResponsible(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    userId: undefined,
    userName: undefined,
    userCode: undefined,
    responsibilityType: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>